#ifndef _NVRIVA_H
#define _NVRIVA_H

#include <kgi/kgi.h>
#include "riva_hw.h"

/* Very useful macro that allows you to set overflow bits */
#define SetBitField(value,from,to) SetBF(to,GetBF(value,from))
#define SetBit(n) (1<<(n))
#define Set8Bits(value) ((value)&0xff)

#define NUM_SEQ_REGS 0x05
//#define NUM_CRT_REGS 0x19
#define NUM_CRT_REGS 0x41
#define NUM_GRC_REGS 0x09
#define NUM_ATC_REGS 0x15

struct riva_regs 
{
	kgiu8 attr[NUM_ATC_REGS];
	kgiu8 crtc[NUM_CRT_REGS];
	kgiu8 gra[NUM_GRC_REGS];
	kgiu8 seq[NUM_SEQ_REGS];
	kgiu8 misc_output;
	RIVA_HW_STATE ext;
};

struct chipset_private
{
	struct nvstate_kgi *newmode;
	kgiu32 clock;
};

#define GET_PRIVATE \
	struct chipset_private *priv = KGIM_PRIVATE(dpy, chipset)

                       
#endif /* _NVRIVA_H */
